--[[Aqui se configuran las caracteristicas de la aplicacion]]--

ID001TC.cfg_.title = getText("terminal de zerozelta",ID001TC)
ID001TC.cfg_.title_for_accs = getText("accs dir",ID001TC)
ID001TC.cfg_.multiLoad = true

---------------------------------------------------------------
---------------------------------------------------------------

system.dofile("ms0:/FISHELL/APP/ID001TC/src/consola.lua")

--[[ FUNCIONES BASICAS ]]--

function ID001TC.init(id,input) --[[ Aqui se coloca lo que se ejecutar al iniciar la aplicacion (incluyendo la carga de recursos) ]]--
id.path = "ms0:/fishell/"

if files.exists("ef0:/") then
	id.path = "ef0:/fishell/"
end

if input ~= nil then
	ruta = uld.getFile(input)
	if ruta ~= nil then
		if ruta.directory == true then
			id.path = ruta.name
		else
		
		end
	end
end

id.textfield = sdk.textfield.new(0,208 - 30,sdk.w)
sdk.textfield.newEvent(id,id.textfield,ID001TC.textfieldEvent)
id.comand = ""
id.lineas = {}

ID001TC.println(id,getText("terminal de zerozelta",ID001TC))
ID001TC.println(id,"["..id.path.."] ")

end

function ID001TC.run(id) --[[ Aqui se coloca el contenido del programa en ejecucion ]]--

draw.fillrect(sdk.x,sdk.y,sdk.w,sdk.h,color.new(0,0,0))

for i = 1,table.maxn(id.lineas) do
	x = 5
	y = 5 + (i - 1) * 10
	screen.print(sdk.x + x,sdk.y + y,id.lineas[i],0.5,color.new(255,255,255),color.new(20,20,20),"scroll_left",457)
end

sdk.textfield.draw(id.textfield)

end

function ID001TC.exit(id) --[[ Aqui se coloca lo que se ejecutar al finalizar la aplicacion (se pueden liberar elementos individuales) ]]--

end

function ID001TC.free() --[[ Aqui se liberan los recursos que fueron requeridos (se eliminan los elementos GLOBALES) ]]--

end

-------------------------------------

---[[ FUNCIONES EXTRAS ]]--

function ID001TC.textfieldEvent(id,obj)
if obj == nil or obj.text == nil then return end

if id.isWait == true then
	id.valorInput = obj.text
	id.lastValInp = obj.text
	id.isWait = false
	ID001TC.println(id,"["..id.path.."] "..obj.text)
	sdk.textfield.setText(obj,"")
	return
end

ID001TC.println(id,"["..id.path.."] "..obj.text)
ID001TC.insertComand(id,obj.text)
sdk.textfield.setText(obj,"")

end

function ID001TC.println(id,texto)
	if #id.lineas > 15 then table.remove(id.lineas,1); end
	table.insert(id.lineas,texto)
end