---Aplicacion Panel de Control

ID003PC.cfg_.title = getText("titulo",ID003PC)
ID003PC.cfg_.multiLoad = false
ID003PC.cfg_.title_for_accs = getText("accs dir",ID003PC)
ID003PC.path = "ms0:/FISHELL/APP/ID003PC"
---------------------------------------------------------------
---------------------------------------------------------------

--[[ FUNCIONES BASICAS ]]--

function ID003PC.init(id,input) --[[ Aqui se coloca lo que se ejecutar al iniciar la aplicacion (incluyendo la carga de recursos) ]]--
	if input == nil then
		id.screen = "main"
	else
		id.screen = input
	end
	
	ID003PC.loadScreen(id.screen,false)
	
end

function ID003PC.run(id) --[[ Aqui se coloca el contenido del programa en ejecucion ]]--
	if id.alerta == nil then
		id.alerta = true
	end
	
	if ID003PC.apprun ~= nil then
		ID003PC.apprun()
	end
end

function ID003PC.exit(id) --[[ Aqui se coloca lo que se ejecutar al finalizar la aplicacion (se pueden liberar elementos individuales) ]]--

end

function ID003PC.free() --[[ Aqui se liberan los recursos que fueron requeridos (se eliminan los elementos GLOBALES) ]]--

end

-------------------------------------

---[[ FUNCIONES EXTRAS ]]--

function ID003PC.makePopup()

end

function ID003PC.loadScreen(type,label)

	if label == nil then
		label = true
	end
	
	if label == true then system.printLabel("03","Cargando seccin") end

	if type == nil then type = "main" end
	
	if files.exists(ID003PC.path.."/src/screen/"..type..".lua") == false then 
		type = "main"
	end
	
	if ID003PC.appfree ~= nil then
		ID003PC.appfree()
	end
	
	system.dofile(ID003PC.path.."/src/screen/"..type..".lua")
	
	if label == true then system.closeLabel() end
	
	controls.read()
	
	ID003PC.apprun()
end