ID004EA.cfg_.title = getText("titulo",ID004EA)
ID004EA.cfg_.multiLoad = true
ID004EA.cfg_.title_for_accs = getText("titulo",ID004EA)
ID004EA.path = "ms0:/FISHELL/APP/ID004EA"
---------------------------------------------------------------
---------------------------------------------------------------

ID004EA.img_barra = image.load(ID004EA.path.."/src/bar_path.png")
ID004EA.img_foco = image.load(ID004EA.path.."/src/foco.png")
ID004EA.img_exec = image.load(ID004EA.path.."/src/exec.png")
ID004EA.img_popup_button = image.load(ID004EA.path.."/src/popup_button.png")

ID004EA.portapapeles = nil
ID004EA.ppToCut = false

--[[ CARGANDO RECURSOS ]]--

ID004EA.icon = {}
tmp_files = files.listfiles(LOG_THEME_PATH.."CUSTOM/files/")

for i = 1,table.maxn(tmp_files) do
	nombre = files.nopath(tmp_files[i].name)
	if files.ext(tmp_files[i].name) == "png" then
		ID004EA.icon[string.lower(nombre)] = image.load(tmp_files[i].name)
	end
end

tmp_files = nil

---------------------------

--[[ FUNCIONES BASICAS ]]--

function ID004EA.init(id,input) --[[ Aqui se coloca lo que se ejecutar al iniciar la aplicacion (incluyendo la carga de recursos) ]]--

id.ms_root = "ms0:/"

if input ~= nil then
	id.path = input
else
	id.path = id.ms_root
end

id.change_ruta = false

id.id = "ID004EA["..(table.maxn(ID004EA)).."]"
id.files = {}

id.IntervaloSelection = {} --- Creando una tabla de seleccion por interbalos para esta ID

id.page = 1

id.tdb = 0
id.pdb = 0

id.last_title = ""
id.last_size = ""
id.last_tipe = ""
id.last_icon = nil

id.icon_trans = 0

if input ~= nil and input[2] ~= nil then
	ID004EA.loadFile(id,input[2])
else
	ID004EA.loadPath(id)
end

id.scrollbar = scrollbar.new(sdk.x + sdk.w - 10,sdk.y + 4,140,id.page,id.total_pages)

end

function ID004EA.run(id) --[[ Aqui se coloca el contenido del programa en ejecucion ]]--

if id.change_ruta ~= false then
	id.icon_trans = id.icon_trans - 22
	if id.icon_trans <= -22 then
		if id.retro == true then
			id.IntervaloSelection = nil
			id.IntervaloSelection = {}
			ID004EA.loadFile(id,id.change_ruta)
			id.icon_trans = 0
			id.retro = false
			id.change_ruta = false
		else
			if id.enterFolder == true then
				ID004EA.loadPath(id,id.change_ruta,1)
				id.change_ruta = false
				id.icon_trans = 0
				id.enterFolder = false
			end
		end
	end
end

if control.press("l") then
	if id.path == "ms0:/" or id.path == "ef0:/" or id.path == "[SELECTION]" then 
		if id.path == "[SELECTION]" then
			ID004EA.loadPath(id,id.ms_root)
		end
	else 
	--id.change_ruta =  files.nofile(id.path)
	id.change_ruta = id.path
	if string.sub(id.change_ruta,string.len(id.change_ruta),string.len(id.change_ruta)) == "/" then
		id.change_ruta = string.sub(id.change_ruta,1,string.len(id.change_ruta) - 1)
	end
	id.retro = true
	end
end

if app.kernel_scroll_ == true then
	if controls.press("up") then
		id.page = id.page - 1
	end
	
	if controls.press("down") then
		id.page = id.page + 1
	end
	
	if controls.press("left") then
		id.page = id.page - 2
	end
	
	if controls.press("right") then
		id.page = id.page + 2
	end
	
end

if control.press("back") then
	id.IntervaloSelection = nil
	id.IntervaloSelection = {}
	
	if id.path == "ms0:/" or id.path == "ef0:/" or id.path == "[SELECTION]" then 
		if id.path == "[SELECTION]" then
			ID004EA.loadPath(id,id.ms_root)
		end
	else 
		id.change_ruta = id.path
		if string.sub(id.change_ruta,#id.change_ruta,#id.change_ruta) == "/" then
			id.change_ruta = string.sub(id.change_ruta,1,#id.change_ruta - 1)
		end
		id.retro = true
	end
end


px = 0
py = 1

sdk.cristalEffect(2,sdk.h - 48,459,46,100)

id.icon_trans = id.icon_trans + 11

if id.icon_trans > 255 then id.icon_trans = 255 end
if id.icon_trans < 0 then id.icon_trans = 0 end

if table.maxn(id.files) == 0 then
	screen.print(sdk.x + 5,sdk.y + 5,getText("no hay archivos",ID004EA),0.5,color.new(0,0,0,id.icon_trans),color.new(255,255,255,id.icon_trans))
else
	if id.page < 1 then
		id.page = 1
	end
	
	if id.page > id.total_pages then
		id.page = id.total_pages
	end
end


local pressInItem = false


for i = 1 + ((id.page - 1) * 7),((id.page - 1) * 7) + 14 do
	
	if id.files[i] == nil then break end
	
	px = px + 1
	if px > 7 then px = 1; py = py + 1 end
	
	local cx = sdk.x + 7 + ((px - 1) * 50) + ((px - 1) * 15)
	local cy = sdk.y + 5 + ((py - 1) * 50) + ((py - 1) * 21)
	
	local isFolder = id.files[i].obj.directory
	local extencion = files.ext(id.files[i].ruta)
	
	local nombre = id.files[i].nombre
	
	if isFolder == false and extencion ~= nil then 
		nombre = id.files[i].tmp_nombre
	end
	
	local ext_ = extencion
	local isExe = false
	
	if ext_ == nil then
		ext_ = "unknown"
	end
	
	if isFolder == true then
		ext_ = "folder"
	else
		if launch.format[ext_] ~= nil then
			isExe = true 
			if ID004EA.icon[ext_..".png"] == nil then
				ext_ = "unknown"
			end	
		else
			if ID004EA.icon[ext_..".png"] ~= nil then
				ext_ = ext_
			else
				ext_ = "unknown"
			end	
		end
	end
	
	if ID004EA.isSelectedItem(id,i) then ID004EA.img_foco:blend(cx,cy,id.icon_trans) end
	
	ID004EA.icon[ext_..".png"]:blend(cx,cy,id.icon_trans)	
	if isExe == true then ID004EA.img_exec:blend(cx + 30,cy + 34,id.icon_trans) end
	
	if puntero.isOver(cx,cy,50,55) then 
		puntero.overOn("popup_link")
		
		if screen.textwidth(string.lower(nombre),0.5) > 57 then
			ID004EA.setTextEf(cx - 5,id)
			if #id.IntervaloSelection == 0 or ID004EA.isSelectedItem(id,i) then
				if #id.IntervaloSelection > 1 then
					draw.fillrect(cx - 7,cy + 53,62,12,color.new(255,228,0,id.icon_trans - 150))	
				else
					draw.fillrect(cx - 7,cy + 53,62,12,color.new(110,110,110,id.icon_trans - 150))	
				end
			end
			id.textefx = screen.print(id.textefx,cy + 53,string.lower(nombre),0.5,color.new(0,0,0,id.icon_trans),0x0,"scroll_left",55)
		else			
			if #id.IntervaloSelection == 0 or ID004EA.isSelectedItem(id,i) then 
				if #id.IntervaloSelection > 1 then
					draw.fillrect(cx - 7,cy + 53,62,12,color.new(255,228,0,id.icon_trans - 150))	
				else
					draw.fillrect(cx - 7,cy + 53,62,12,color.new(110,110,110,id.icon_trans - 150))	
				end
			end
			uld.printCenter(cx,cy + 53,string.lower(nombre),0.5,color.new(0,0,0,id.icon_trans),0x0,50)
		end
		
		if kernel.isPopup == false and ID004EA.isSelectedItem(id,i) == false then
			ID004EA.img_foco:blend(cx,cy,id.icon_trans - 110)
		end
		
		if control.press("select") then 
		
			pressInItem = true
			
			if isFolder == true and ID004EA.isSelectedItem(id,i) and control.old("r") == false and #id.IntervaloSelection <= 1 then
				id.enterFolder = true --------------- linea de prueva
				id.change_ruta = id.files[i].ruta
			end
			
			if isExe == true and ID004EA.isSelectedItem(id,i) and isFolder == false and control.old("r") == false and #id.IntervaloSelection <= 1 then
				launch.custom(id.files[i].ruta)
			end
			
			if control.old("r") then
				if ID004EA.isSelectedItem(id,i) then
					ID004EA.removeItem(id,i)
				else
					ID004EA.selectItem(id,i,"add")
				end
			else
				ID004EA.selectItem(id,i,"set") ---------> Aqui seteamos foco
			end
		end
		
		
		if control.press("menu") then
			if id.IntervaloSelection ~= nil and #id.IntervaloSelection > 1 and ID004EA.isSelectedItem(id,i) then
				ID004EA.makePopupInterval(id)
			else
				ID004EA.makePopup(id,id.files[i].obj)
				ID004EA.selectItem(id,i,"set")
			end
		end
		
		if #id.IntervaloSelection == 0 or ID004EA.isSelectedItem(id,i) or #id.IntervaloSelection > 1 then
			id.last_title = getText("nombre",ID004EA)..": "..id.files[i].nombre
			id.last_size = getText("tamao",ID004EA)..": "..files.sizeformat(id.files[i].obj.size)
			id.last_icon = ext_..".png"
			if isFolder == true then
				id.last_tipe = getText("tipo",ID004EA)..": ["..getText("folder",ID004EA).."]"
			else
				if files.ext(id.files[i].obj.name) ~= nil then 
					id.last_tipe = getText("tipo",ID004EA)..": "..string.upper(files.ext(id.files[i].obj.name))
				else
					id.last_tipe = getText("tipo",ID004EA)..": "..getText("archivo",ID004EA)
				end
			end
		end
	else
		nombre = string.lower(nombre)
		
		if ID004EA.isSelectedItem(id,i) then
			if #id.IntervaloSelection > 1 then
				draw.fillrect(cx - 7,cy + 53,62,12,color.new(60,60,255,id.icon_trans - 150))
			else
				draw.fillrect(cx - 7,cy + 53,62,12,color.new(110,110,110,id.icon_trans - 150)) 
			end
		end
		
		if screen.textwidth(nombre,0.5) > 54 then
			screen.print(cx - 2,cy + 53,nombre,0.5,color.new(0,0,0,id.icon_trans),0x0,"scroll_left",52)
		else
			uld.printCenter(cx,cy + 53,nombre,0.5,color.new(0,0,0,id.icon_trans),0x0,50)
		end
		
		
	end

end

if id.last_icon ~= nil and app.kernel_scroll_ == false then
ID004EA.icon[id.last_icon]:blend(sdk.x + 4,177 - 7,255)
screen.print(sdk.x + 59,177 + 4,id.last_title,0.58,color.new(20,20,20),color.new(255,255,255,180),"scroll_left",397)
screen.print(sdk.x + 59,177 + 16,id.last_size,0.58,color.new(20,20,20),color.new(255,255,255,180))
screen.print(sdk.x + 59,177 + 28,id.last_tipe,0.58,color.new(20,20,20),color.new(255,255,255,180))
end

if app.kernel_scroll_ == true then
ID004EA.img_barra:blend(sdk.x + 1,174)

if id.path == "[SELECTION]" then
	
else
	screen.print(sdk.x + 32,181,id.path,0.55,color.new(30,30,30),color.new(180,180,180,230),"scroll_left",380)
	screen.print(sdk.x + 32,184 + 20,files.nopath(id.path),0.55,color.new(30,30,30),color.new(180,180,180,230),"scroll_left",130)
end

screen.print(sdk.x + 229,184 + 20,id.total_files,0.55,color.new(30,30,30),color.new(180,180,180,230),"scroll_left",45)
screen.print(sdk.x + 229 + 107,184 + 20,id.page.." / "..id.total_pages,0.55,color.new(30,30,30),color.new(180,180,180,230),"scroll_left",50)
end

if id.total_pages == nil then id.total_pages = 0 end 

scrollbar.setVal(id.scrollbar,id.page,id.total_pages)
scrollbar.draw(id.scrollbar)
scrollbar.setLocation(id.scrollbar,sdk.x + sdk.w - 10,sdk.y + 4)

if fishbar.apps[fishbar.apps_focus].titulo ~= id.titulo then fishbar.apps[fishbar.apps_focus].titulo = id.titulo end

if control.press("select") and pressInItem == false and control.old("r") == false and puntero.isOver(sdk.x,sdk.y,sdk.w,sdk.h) then
	id.IntervaloSelection = nil
	id.IntervaloSelection = {}
end


if puntero.isOver(sdk.x + 432,sdk.y + 171,27,23) and app.kernel_scroll_ == false then
	puntero.overOn("link")
	ID004EA.img_popup_button:blend(sdk.x + 432,sdk.y + 171,255)
	if control.press("select") == true and kernel.isPopup == false then
		ID004EA.makePopupBack(id)
	end
else
	if app.kernel_scroll_ == false then
		ID004EA.img_popup_button:blend(sdk.x + 432,sdk.y + 171,130)	
	end
end

if puntero.isOver(sdk.x,sdk.y,sdk.w,sdk.h) then
	if control.press("menu") == true and kernel.isPopup == false then
		ID004EA.makePopupBack(id)
	end
end

end

function ID004EA.exit(id) --[[ Aqui se coloca lo que se ejecutar al finalizar la aplicacion (se pueden liberar elementos individuales) ]]--

end

function ID004EA.free() --[[ Aqui se liberan los recursos que fueron requeridos (se eliminan los elementos GLOBALES) ]]--

end

-------------------------------------

---[[ FUNCIONES EXTRAS ]]--

function ID004EA.loadPath(id,ruta,page,doc)

if doc ~= nil then
doc = string.lower(doc)
end

if ruta == nil then ruta = id.path end
if page == nil then page = id.page end

if page == nil then page = 1 end

if files.exists(ruta) == false then ruta = "ms0:/" end

if page <= 0 then page = 1 end

local tmp_files
id.files = nil
id.files = {}

if type(ruta) == "string" then
	tmp_files = ID004EA.fileslist(ruta)
else
	tmp_files = ruta
	id.path = "[SELECTION]"
end

if ruta == id.path then

else
	id.IntervaloSelection = nil
	id.IntervaloSelection = {}
end

max_page = math.floor(#tmp_files / 7)

if max_page == 0 and #tmp_files > 0 then
	max_page = math.ceil(#tmp_files / 7)
end

id.total_pages = max_page
id.total_files = table.maxn(tmp_files)

if page > max_page then page = max_page end


for i = 1 ,#tmp_files do	
	if tmp_files[i] == nil then break end
	
	if doc ~= nil and string.lower(tmp_files[i].name) == doc then
		ID004EA.selectItem(id,i,"set")
		page = math.max(math.floor(i / 7),1);
	end
	
	id.files[i] = { nombre = files.nopath(tmp_files[i].name) , ruta = tmp_files[i].name , extencion = files.ext(tmp_files[i].name) , obj = tmp_files[i] }
		
	local extencion = files.ext(tmp_files[i].name)
	local nombre = files.nopath(tmp_files[i].name)
	
	if tmp_files[i].directory == false and extencion ~= nil then 
		id.files[i].tmp_nombre = string.sub(files.nopath(tmp_files[i].name),0,#files.nopath(tmp_files[i].name) - (#extencion + 1)) 
	end
		
end

id.page = page
if id.path ~= "[SELECTION]" then
	id.path = ruta
end

id.last_title = ""
id.last_size = ""
id.last_tipe = ""
id.last_icon = nil
id.textlastx = nil

if fishbar.apps_focus ~= 0 then 
	if id.path == "[SELECTION]" then
		fishbar.apps[fishbar.apps_focus].titulo = getText("titulo",ID004EA)
	else
		fishbar.apps[fishbar.apps_focus].titulo = getText("titulo",ID004EA).." - "..files.nopath(id.path)	
	end
end


id.titulo = getText("titulo",ID004EA).." - "..files.nopath(id.path)

if string.sub(id.titulo,#id.titulo,#id.titulo) == "/" then
	id.titulo = string.sub(id.titulo,1,#id.titulo - 1)
end


if doc ~= nil then 
ID004EA.printData(id,doc) 
end

end

function ID004EA.makePopup(id,archivo)
---element[ejem] = { texto = (nombre del elemento) , accion = (accion de la pulsacion) , est = (boleano que avilita/desavilita el elemento) }

local eleme = {}
local tipo = "FILE"

if archivo.directory == true then 
	tipo = "FOLDER" 
else
	if files.ext(archivo.name) == "pbp" then
		tipo = "EBOOT"
	end
end

if tipo ~= "FOLDER" then
	table.insert(eleme,{ texto = getText("abrir con",ID004EA) , accion = "" , est = false })
end



if files.ext(archivo.name) == "png" or files.ext(archivo.name) == "jpg" then
	table.insert(eleme,{ texto = getText("establecer como fondo",ID004EA) , accion = "descktop.makeBackg(\""..archivo.name.."\")" , est = true })
end

if archivo.directory == true then
	table.insert(eleme,{ texto = getText("abrir otra ventana",ID004EA) , accion = "launch.custom(\""..archivo.name.."\")" , est = true , accionToClose = true })
end

if tipo == "EBOOT" then
	nombre = files.nofile(archivo.name)
	nombre = files.nopath(nombre)
	nombre = string.lower(nombre)
	nombre = string.sub(nombre,0,string.len(nombre) - 1)
	table.insert(eleme,{ texto = getText("crear accs",ID004EA) , accion = "descktop.makeAccsDir(\""..nombre.."\",\"image\",\""..tipo.."\",\""..archivo.name.."\")" , est = true })
else
	table.insert(eleme,{ texto = getText("crear accs",ID004EA) , accion = "descktop.makeAccsDir(\""..string.lower(files.nopath(archivo.name)).."\",\"image\",\""..tipo.."\",\""..archivo.name.."\")" , est = true })
end

func_rename = "ID004EA.loadFile("..id.id..",".."sdk.renameFile(\""..archivo.name.."\")"..")"

table.insert(eleme,{ texto = getText("renombrar",ID004EA) , accion = func_rename, est = true , accionToClose = true })
table.insert(eleme,{ texto = getText("copiar",ID004EA) , accion = "ID004EA.portapapeles = '"..archivo.name.."'; ".." ID004EA.ppToCut = false"  , est = true })
table.insert(eleme,{ texto = getText("cortar",ID004EA) , accion = "ID004EA.portapapeles = '"..archivo.name.."'; ".." ID004EA.ppToCut = true" , est = true })
if tipo == "FOLDER" and ID004EA.portapapeles ~= nil then
	local chunk_pegar
	
	if ID004EA.ppToCut == true then
		chunk_pegar = "ID004EA.loadFile("..id.id..",sdk.cutFile('"..ID004EA.portapapeles.."','"..archivo.name.."'))"
	else
		chunk_pegar = "ID004EA.loadFile("..id.id..",sdk.copyfile('"..ID004EA.portapapeles.."','"..archivo.name.."'))"
	end
	
	table.insert(eleme,{ texto = getText("pegar adentro",ID004EA) , accion = chunk_pegar , est = true , accionToClose = true })
end

table.insert(eleme,{ texto = getText("eliminar",ID004EA) , accion = "ID004EA.delDir("..id.id..",\""..archivo.name.."\")" , est = true , accionToClose = true })

if tipo ~= "FOLDER" then
	table.insert(eleme,{ texto = getText("enviar",ID004EA).." (ms-ms)" , accion = "launch.sendMS('"..archivo.name.."')" , est = true , accionToClose = true })
end

table.insert(eleme,{ texto = getText("propiedades",ID004EA) , accion = "sdk.getPropieties(\""..archivo.name.."\")" , est = true , accionToClose = true })

popup.setElements(eleme)
popup.activate()
end

function ID004EA.makePopupInterval(id)
	local eleme = {}
	
	table.insert(eleme,{ texto = "Elemento 1" , accion = "" , est = true , accionToClose = true })
	table.insert(eleme,{ texto = "Elemento 2" , accion = "" , est = true , accionToClose = true })
	table.insert(eleme,{ texto = "Elemento 2" , accion = "" , est = true , accionToClose = true })
	
	popup.setElements(eleme)
	popup.activate()
end


function ID004EA.makePopupBack(id)

id.IntervaloSelection = nil
id.IntervaloSelection = {}
	
local eleme = {}

local chunk_copy

local isPortap = false

if ID004EA.portapapeles ~= nil and id.path ~= "[SELECTION]" then
	isPortap = true
	--chunk_copy = "local resultado = sdk.copyfile('"..ID004EA.portapapeles.."','"..id.path.."') \n  if resultado ~= nil then ID004EA.loadPath("..id.id..",files.nofile('resultado')); ID004EA.loadFile("..id.id..",'resultado') end"
	if ID004EA.ppToCut == true then
		chunk_copy = "ID004EA.loadFile("..id.id..",sdk.cutFile('"..ID004EA.portapapeles.."','"..id.path.."'))"
	else
		chunk_copy = "ID004EA.loadFile("..id.id..",sdk.copyfile('"..ID004EA.portapapeles.."','"..id.path.."'))"
	end
else
	chunk_copy = ""
end

if id.path ~= "[SELECTION]" then
	table.insert(eleme,{ texto = getText("pegar",ID004EA) , accion = chunk_copy , est = isPortap , accionToClose = true})
	table.insert(eleme,{ texto = getText("nuevo folder",ID004EA) , accion = "ID004EA.loadFile("..id.id..",sdk.mkdir('"..id.path.."'))" , est = true , accionToClose = true})
	table.insert(eleme,{ texto = getText("nuevo archivo",ID004EA) , accion = "ID004EA.loadFile("..id.this.IDI..",ID004EA.createFile("..id.this.IDI.."))" , est = true , accionToClose = true})
end

table.insert(eleme,{ texto = getText("buscar",ID004EA) , accion = "" , est = false , accionToClose = true})
table.insert(eleme,{ texto = getText("filtrar",ID004EA) , accion = "" , est = false, accionToClose = true})

popup.setElements(eleme)
popup.activate()
end

function ID004EA.loadFile(id,doc)
if doc == nil then return end
doc = string.lower(doc)

if files.exists(doc) == false then
	system.mensaje(getText("error"),"",getText("el archivo no existe"))
	ID004EA.loadPath(id,"ms0:/",1)
	return
end

archivos = ID004EA.fileslist(files.nofile(doc))
index = 0
id.srcDir = false

for i = 1,table.maxn(archivos) do
	if string.lower(archivos[i].name) == doc then
		index = i
		if archivos[i].directory == true then
			id.srcDir = true
		end
		break
	end
end

page = math.ceil(index / 14)
ID004EA.loadPath(id,files.nofile(doc),page,doc)

end

function ID004EA.refresh(id)
	if id.path == "[SELECTION]" then
		ID004EA.loadPath(id,id.path,id.page)
		return
	end
	ID004EA.loadPath(id,id.path,id.page)
end

function ID004EA.fileslist(ruta)
tmp_files = files.list(ruta)
table.sort(tmp_files,ID004EA.ordenador)
return tmp_files
end

function ID004EA.ordenador(a,b)

if a.directory == b.directory then
	return a.name < b.name
end

return a.directory
end

function ID004EA.delDir(id,ruta)
if ruta == nil or files.exists(ruta) == false then 
	system.mensaje(getText("error"),"",getText("el archivo a eliminar no existe",ID004EA))
	return
end

local chunk = "ID004EA.mkdelDir("..id.id..",\""..ruta.."\")"
optionpanel.init(getText("desea eliminar",ID004EA)..": "..files.nopath(ruta).."?",chunk)

id.IntervaloSelection = nil
id.IntervaloSelection = {}
end

function ID004EA.mkdelDir(id,ruta)
sdk.deleteFile(ruta,true)
ID004EA.refresh(id)
end

function ID004EA.setTextEf(inicial,id)
if id.textlastx == inicial then return end
id.textlastx = inicial
id.textefx = inicial 
end


function ID004EA.printData(id,ruta)
	if files.exists(ruta) == false then	return end
	
	obj_file = ID004EA.getObj_file(ruta)
	
	local ext = ""
	
	if obj_file.obj.directory == true then
		ext = "folder"
	else
		ext = files.ext(obj_file.ruta)
		if ext == nil then ext = "" end
		
		if ID004EA.icon[ext..".png"] ~= nil then
			ext = ext
		else
			ext = "unknown"
		end	
	end

	id.last_title = getText("nombre",ID004EA)..": "..obj_file.nombre
	id.last_size =  getText("tamao",ID004EA)..": "..files.sizeformat(obj_file.obj.size)
	id.last_icon = ext..".png"
	
	if ext == "folder" then
		id.last_tipe = getText("tipo",ID004EA)..": ["..getText("folder",ID004EA).."]"
	else
		if files.ext(obj_file.obj.name) ~= nil then 
			id.last_tipe = getText("tipo",ID004EA)..": "..string.upper(files.ext(obj_file.ruta))
		else
			id.last_tipe = getText("tipo",ID004EA)..": "..getText("archivo",ID004EA)
		end
	end
end

function ID004EA.getObj_file(ruta) 
	if files.exists(ruta) == false then return end
	
	local file = uld.getFile(ruta)
	local obj = { nombre = files.nopath(file.name) , ruta = file.name , extencion = files.ext(file.name) , obj = file }
	return obj
end

function ID004EA.createFile(id)
	system.loadOsk()
	archivo = osk.getText(getText("escriba nuevo nombre",ID004EA),"",59);
	
	if archivo == nil then
		return;
	end
	
	local path = id.path
	
	if string.sub(path,#path,#path) == "/" then
		path = string.sub(path,1,#path - 1)
	end
	
	local result = path.."/"..archivo
	
	if files.exists(result) then
		system.mensaje("Alerta","",getText("ya existe el archivo_",ID004EA).." "..archivo.." "..getText("no se cambio",ID004EA));
	end
	
	system.printLabel("03",getText("cargando archivo",ID004EA))
	screen.waitvblankstart(20)
	
	uld.writeFile(result,"","w+")
	
	system.closeLabel()
	
	if files.exists(result) == false then
		system.mensaje(getText("error"),"",getText("no se creo archivo",ID004EA).." "..archivo)
		return
	end
	
	return result
end

function ID004EA.selectItem(id,index,metod)

if metod == "set" then
	id.IntervaloSelection = nil
	id.IntervaloSelection = {}
	
	table.insert(id.IntervaloSelection,index)
	return
end

if metod == "add" then
	if ID004EA.isSelectedItem(id,index) == true then return end
	table.insert(id.IntervaloSelection,index)
	return
end


end

function ID004EA.removeItem(id,index)
	local isTrue,position_i = ID004EA.isSelectedItem(id,index)
	
	if isTrue == true then
		table.remove(id.IntervaloSelection,position_i)
	end
end

function ID004EA.isSelectedItem(id,index)

	local isExist = false
	local result_index = nil
	
	for i = 1,#id.IntervaloSelection do
		if id.IntervaloSelection[i] == index then
			isExist = true
			result_index = i
			break;
		end
	end
	
	return isExist,result_index
end