--[[ modulo launcher ]]--
--- Documentacon para acceder y abrir archivos
-- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com

launch = {}
launch.format = {}

function launch.app(id,input) --- Carga una aplicacion con el id pasado como argumento
	app.load(id,input)
end

function launch.load() --- Carga la base de ejecuciones (archivo que indica con que programa abrir cada archivo)
if files.exists(LOG_PATH.."CUSTOM/exec.ini") == false then
	system.mensajeCritico("error code 009")
end

dofile(LOG_PATH.."CUSTOM/exec.ini")
end

function launch.explorerFile(archivo) --- Muestra un archivo en el explorador 
if files.exists(archivo) == false then
	system.mensaje(getText("error"),"",getText("el archivo no existe"))
	return
end

res = {}
res[1] = "null"
res[2] = archivo
launch.app(launch.format["default explorer"],res)
end


function launch.custom(ruta) --- abre un archivo con su porgrama correspondiente basandose en la base ejecuciones
if files.exists(ruta) == false then return end

isDir = uld.getFile(ruta).directory
ext = files.ext(ruta)

if isDir == nil then isDir = false end

if ext == nil or isDir == true then
	if isDir == true then
		app.load(launch.format["default explorer"],ruta)
		return
	else
		system.mensaje(getText("advertencia"),"",getText("no se puede abrir el archivo"))
		return
	end
end

if launch.format[ext] == nil then
	system.mensaje(getText("advertencia"),"",getText("no se puede abrir el archivo"))
	return
end

if launch.format[ext] == "ESPECIAL" then
	launch.especial(ruta,ext) 
	return
end

APP = launch.format[ext]

if files.exists("ms0:/FISHELL/APP/"..APP.."/app.lua") == false and files.exists("ms0:/FISHELL/APP/"..APP.."/app.lue") == false then
	system.mensaje(getText("advertencia"),"",getText("no se puede abrir el archivo"))
	return
end

app.load(APP,ruta)

end

function launch.especial(ruta,ext) --- Carga un archivo en modo especial (fuera del shell)
	if ext == "pbp" then launch.eboot(ruta) end ----> acabar esta funcion
	if ext == "htm" or ext == "html" or ext == "php" or ext == "swf" then launch.www(ruta) end
	if ext == "iso" or ext == "cso" then launch.iso(ruta) end
end

function launch.lhms(script,txt_input,eboot_path) --- Corre un archivo de luaHM donde script es el archivo base, txt_input son las variables pasadas a la aplicacion
if files.exists("ms0:/FISHELL/LHM/LIB/"..script) == false then return end

files.copy("ms0:/FISHELL/LHM/LIB/"..script,"ms0:/FISHELL/LHM/FUNCTION.LUA",true,true)

if txt_input == nil then
	 txt_input = ""
end

txt_input = txt_input.."\nFS = {}\n"
txt_input = txt_input..txt_input.."FS.path = '"..system.path.."'\n"
txt_input = txt_input..txt_input.."FS.user = '"..LOG_USER.."'\n"
txt_input = txt_input..txt_input.."FS.language = '"..LOG_LENGUAGE.."'\n"

system.efectDifuse()
uld.writeFile("ms0:/FISHELL/LHM/input.txt",txt_input,"w")

if eboot_path == nil then
	os.runeboot("ms0:/FISHELL/LHM/EBOOT.PBP")
else
	if files.exists(eboot_path) then
		os.runeboot(eboot_path)
	end
end

end

function launch.accsFile(ruta)
	ext = files.ext(ruta)
	
	if launch.format[ext] == nil then
		system.mensaje(getText("aviso"),"",getText("no se puede cargar el archivo"))
	else
		launch.custom(ruta)
	end
end

function launch.iso(ruta) --- Carga un archivo ISO
chunk =	"if files.exists(\""..ruta.."\") then system.printLabel(\"05\",getText(\"cargando\")); screen.waitvblankstart(40); system.efectDifuse(); os.runiso(\""..ruta.."\") end"
optionpanel.init(getText("deseas iniciar juego").." "..getText("(se cerraran ventanas)"),chunk)
end

function launch.psx(ruta) --- Carga un eboot de PSX
--[[ FUNCION REMOVIDA EN EL SCENERY EDITION ]]--
end

function launch.umd() --- Inicia la unidad umd
if umd.present() == true then
	local chunk = "system.printLabel('05',getText('cargando')); screen.waitvblank(60); launch.lhms('run_umd.lua','text = \""..getText("cargando").."\"')"
	optionpanel.init(getText("deseas iniciar juego").." "..getText("(se cerraran ventanas)"),chunk)
else
	system.mensaje(getText("mensaje"),"",getText("umd no encontrado"))
end

end

function launch.dump_umd() --- Dumpea la unidad umd
if umd.present() == true then
	local chunk = "dofile('ms0:/FISHELL/src/functions/dump_umd.lua')"
	optionpanel.init(getText("deseas umd dumper?").." "..getText("(se cerraran ventanas)"),chunk)
else
	system.mensaje(getText("mensaje"),"",getText("umd no encontrado"))
end

end

function launch.www(ruta) --[[PHP HTML HTM SWF]]-- inicia un archivo con el explorador web
if ruta == nil then
	optionpanel.init(getText("deseas exploradore web?").." "..getText("(se cerraran ventanas)"),"launch.mkwww()")
	return
end

optionpanel.init(getText("deseas exploradore web?").." "..getText("(se cerraran ventanas)"),"launch.mkwww('"..ruta.."')")
end

function launch.mkwww(ruta)
	if ruta == nil then
		ruta = cfg.homepageweb
	else
		if files.exists(ruta) then
			ruta = string.lower("file:/"..string.sub(ruta,6,string.len(ruta)))
		end
	end
	
	system.printLabel("03",getText("cargando"))
	screen.waitvblank(30)
	launch.lhms("www.lua","ruta = \""..ruta.."\"")
end

function launch.mp4() --[[ MP4 ]]--

end

--[[
function launch.portal(nombre)
	return dofile("ms0:/FISHELL/SRC/PORTAL/"..nombre.."/portal.lua")
end
--]]

function launch.eboot(ruta) --[[PBP y PSX]]-- PENDIENTE PSX
	if files.ext(ruta) ~= "pbp" then return false end
	
	system.dofile("ms0:/FISHELL/SRC/DOC/eloader.lua")
	eloader.loadEboot(ruta)
end

function launch.nand_dumper(forzar) -- Inicia el open nand dumper
	if files.exists("ms0:/FISHELL/SRC/PORTAL/OPENNAND/EBOOT.pbp") == false then
		system.mensaje("Error","","Not exist Nand Dumper portal")
		return false
	end
	
	if files.freespace() > 70000000 then else
		system.mensaje(getText("aviso"),"",getText("no hay espacio, requieren").." "..files.sizeformat((70000000 - files.freespace()))..getText("mas")..".")
		return false
	end
	
	if forzar == nil then
		optionpanel.init(getText("deseas nand dumper?").." "..getText("(se cerraran ventanas)"),"launch.nand_dumper(true)")
		return true
	end
	
	system.mensaje(getText("comenzando respaldo nand"),"",getText("la nand se guardara en"))
	system.efectDifuse()
	
	os.runeboot("ms0:/FISHELL/SRC/PORTAL/OPENNAND/EBOOT.pbp")
end

function launch.sendMS(ruta) -- Envia un archivo por medio de la memory stick Modulo: mss.lua
	if files.exists(ruta) == false then 
		system.mensaje(getText("error"),"",getText("el archivo no existe"))
		return
	end
	
	local archivo = uld.getFile(ruta)
	local size_pack = (os.getinitmemory() / 2) - 620000
	
	if archivo.size > (1024 * 1000) * 80 then -- El archivo no puede sobrepasar los 80 Mb de tamao
		system.mensaje(getText("aviso"),"",getText("el achivo a enviar es muy grande"))
		return
	end
	
	optionpanel.init(getText("desea enviar el archivo:").." "..files.nopath(ruta).." (ms-ms)? "..getText("(se cerraran ventanas)"),"launch.mksendMS('"..ruta.."')")
end

function launch.mksendMS(ruta)
	if files.exists("ms0:/FISHELL/ms-ms.send") == true then
		system.mensaje(getText("aviso"),"",getText("se detecto una solicitud de envio"))
		return
	end
	
	system.printLabel("load","")
	system.dofile("ms0:/FISHELL/SRC/DOC/mss.lua")
	
	system.mensaje("Mensaje","","Seleccione en donde desea escribir el archivo de destino")
	
	FILE_SELECTOR_TYPE = "folders"						--- Solo se permiten directorios
	FILE_SELECTOR_NAME_FILTER = "Ruta de destino"		--- Nombre del filtro
	FILE_SELECTOR_INIT_PATH = "ms0:"					--- Current directory (directorio de trabajo)
	FILE_SELECTOR_ROOT_ENABLED = true
	
    local destino = system.runPortal("ms0:/FISHELL/SRC/PORTAL/FILE_SELECTOR")
	
	if destino == nil then
		system.closeLabel()
		return
	end
	
	MSS.crearSolicitud(ruta,destino)
	system.closeLabel()
	
	system.makeSesion(LOG_USER,LOG_PASSWORD,"0945.8721.0902.8752") -- Reinicia el logo de tu sesion
	system.reloadSystem()
end

launch.load() 
