---- Modulo para el menu principal del fishell 
-- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com

main_menu = {}
main_menu.x = -250
main_menu.close_chunk = nil
main_menu.transaf = 0
main_menu.nickbtrans = 0

main_menu.img_panel = image.load(LOG_THEME_PATH.."CUSTOM/system/main_menu/main_menu.png")
main_menu.img_foco = image.load(LOG_THEME_PATH.."CUSTOM/system/main_menu/foco.png")
main_menu.avatar_focus = image.load(LOG_THEME_PATH.."CUSTOM/system/main_menu/avatar_focus.png")
main_menu.img_shutdown = image.load(LOG_THEME_PATH.."CUSTOM/system/main_menu/shutdown.png")
main_menu.img_nickbaloon = image.load(LOG_THEME_PATH.."CUSTOM/system/main_menu/nick_baloon.png")

main_menu.panel = {}
main_menu.panel[1] = {
	"app.load('ID006MP')",
	"system.mensaje(getText('aviso'),'',getText('funcion no en esta version'))",
	"app.load('ID003PC')",
	"system.mensaje(getText('aviso'),'',getText('funcion no en esta version'))",
	"app.load('ID004EA')"
}

if files.exists(LOG_PATH.."avatar.png") then
	LOG_AVATAR = image.load(LOG_PATH.."avatar.png")
	LOG_AVATAR:resize(80,80)
else
	
end

function main_menu.draw()
if fishbar.panel_activado == false and main_menu.x <= -250 then return end

puntero.overOn()

if fishbar.panel_activado == true then
	if semaforo.x <= (0 - semaforo.w) then
		main_menu.x = main_menu.x + 8
	end
else
	main_menu.x = main_menu.x - 8
end

if main_menu.x < -250 then	main_menu.x = -250 end
if main_menu.x > 0 then main_menu.x = 0 end

main_menu.drawInit()

if controls.press(control.config["back"]) then
	main_menu.desactivate()
end

if controls.press(control.config["menu"]) then
	main_menu.desactivate()
end

if controls.press("l") then
	main_menu.desactivate()
end

if controls.press("r") then
	main_menu.desactivate()
end

if controls.press(control.config["home"]) or controls.press("home") then
	home.run()
end

if puntero.isOver(main_menu.x,2,205,230) then else
	if controls.press(control.config["select"]) and puntero.isOver(main_menu.x + 160,8,80,80) == false then
		main_menu.desactivate()
	end
end

if main_menu.close_chunk ~= nil and fishbar.panel_activado == false and main_menu.x <= -250 then
	assert(loadstring(main_menu.close_chunk))();
	main_menu.close_chunk = nil
end

end

function main_menu.activate()
	fishbar.panel_activado = true
	main_menu.nickbtrans = 0
	controls.read()
end

function main_menu.desactivate(chunk)
	fishbar.panel_activado = false
	if chunk ~= nil then main_menu.close_chunk = chunk end
end

function main_menu.drawInit()
	main_menu.img_panel:blend(main_menu.x,0,255)
	LOG_AVATAR:blend(main_menu.x + 160,8,255)
	
	if fishbar.panel_activado == true and main_menu.x == 0 then 
		main_menu.nickbtrans = main_menu.nickbtrans + 4
	else
		main_menu.nickbtrans = main_menu.nickbtrans - 8
	end
	
	if main_menu.nickbtrans < 0 then main_menu.nickbtrans = 0 end
	if main_menu.nickbtrans > 255 then main_menu.nickbtrans = 255 end
	
	main_menu.img_nickbaloon:blend(main_menu.x + 148,90,main_menu.nickbtrans)
	
	if puntero.isOver(main_menu.x + 148,90,107,19) then
		puntero.overOn("link")
		screen.print(main_menu.x + 199,96,LOG_USER,0.65,color.new(220,220,220,main_menu.nickbtrans),color.new(255,255,255,main_menu.nickbtrans - 180),"center",107)
	else
		screen.print(main_menu.x + 199,96,LOG_USER,0.54,color.new(220,220,220,main_menu.nickbtrans),0x0,"center",107)
	end

	
	if main_menu.transaf > 0 then
		main_menu.avatar_focus:blend(main_menu.x + 160,8,main_menu.transaf)
	end
	
	if puntero.isOver(main_menu.x + 160,8,80,80) then	
		puntero.overOn("link")
		main_menu.transaf  =  main_menu.transaf  + 5
	else
		main_menu.transaf = main_menu.transaf  - 5
	end
	
	if main_menu.transaf < 0 then main_menu.transaf  = 0 end
	if main_menu.transaf  > 255 then main_menu.transaf = 255 end
	
	screen.print(main_menu.x + 24,186,getText("todos los programas"),0.5,color.new(20,20,20),0x0)
	if puntero.isOver(main_menu.x + 6,182,138,18) then
		puntero.overOn("link")
		draw.fillrect(main_menu.x + 6,182,138,18,color.new(38,161,212,120))
		if controls.press(control.config["select"]) then
			main_menu.desactivate("launch.app('ID007TA')");
		end
	end
	
	 ---- Comienza el divujado del panel de opciones 
	
	for i = 1,5 do
		local x = main_menu.x + 6
		local y = 10 + ((i - 1) * 34)
		
		if puntero.isOver(x,y,138,33) then
			puntero.overOn("link")
			if controls.press(control.config["select"]) then
				main_menu.desactivate(main_menu.panel[1][i])
			end
			main_menu.img_foco:blend(x,y,100)
		end
		
		screen.print(x + 40,y + 8,getText("mm_"..i),0.5,color.new(30,30,30),color.new(170,170,170),"left",95)
		
	end
	
	if puntero.isOver(main_menu.x + 151,205,41,15) then
		puntero.overOn("link")
		if controls.press(control.config["select"]) then
			main_menu.desactivate("system.runPortal('ms0:/FISHELL/SRC/PORTAL/SHUTDOWN')");
		end
		main_menu.img_shutdown:blend(main_menu.x + 151,205,255)
	else
		main_menu.img_shutdown:blend(main_menu.x + 151,205,180)
	end
	
end