--- Selector de idioma

local img_screen = screen.toimage()
local langs = {}
langs = files.listdirs("ms0:/FISHELL/LANG")
local eleme = {}
local foco = 1
local result = nil
local bucle = true

system.printLabel("03",getText("cargando"))

for i = 1,#langs do
	if files.exists(langs[i].name.."/main.lua") and files.nopath(langs[i].name) ~= "UNKNOWN" then
		table.insert(eleme,files.nopath(langs[i].name))
	end
end
 
local function drawList(trans)
	img_screen:blit(0,0)
	draw.gradrect(0,0,480,272,color.new(70,70,255,trans),color.new(70,70,255,trans),color.new(0,0,255,trans),color.new(0,0,255,trans))

	screen.print(5,5,"Language: Press X to select item",0.6,color.new(255,255,255,trans),color.new(30,30,30,trans))
	
	if foco < 1 then foco = 1 end
	if foco > #eleme then foco = #eleme end
	
	for i = 1,#eleme do
		local x = 5
		local y = 30 + ((i - 1) * 16)
		
		if foco == i then
			draw.fillrect(x,y,300,15,color.new(30,30,30,trans))
			screen.print(x + 3,y + 3,eleme[i],0.58,color.new(200,200,200,trans),0x0)
		else
			draw.fillrect(x,y,300,15,color.new(200,200,200,trans))
			screen.print(x + 3,y + 3,eleme[i],0.58,color.new(30,30,30,trans),0x0)
		end
		
	end
	
	screen.flip()
	
	if trans == 255 then
		controls.read()
		
		if controls.press("up") then
			foco = foco - 1
			return
		end
		
		if controls.press("down") then
			foco = foco + 1
			return
		end
		
		if controls.press("cross") then
			result = eleme[foco]
			bucle = false
			return
		end
	end
end

system.closeLabel()

for i = 0,255,12 do
	drawList(i)
end

while bucle do
	drawList(255)
end

for i = 255,-11,-11 do
	drawList(i)
end

return result