--[[Aqui se configuran las caracteristicas de la aplicacion]]--

ID002RM.cfg_.title = getText("titulo",ID002RM)
ID002RM.cfg_.multiLoad = false
ID002RM.cfg_.title_for_accs = getText("accs dir",ID002RM)
ID002RM.path = "ms0:/FISHELL/APP/ID002RM"
---------------------------------------------------------------
---------------------------------------------------------------

ID002RM.img_fondo = image.load(ID002RM.path.."/src/background.png")
ID002RM.img_fpoint = image.load(ID002RM.path.."/src/focus_point.png")
ID002RM.img_point = image.load(ID002RM.path.."/src/point.png")
ID002RM.img_Bplay = image.load(ID002RM.path.."/src/bplay.png")
ID002RM.img_Bpause = image.load(ID002RM.path.."/src/bpause.png")
ID002RM.img_Blast = image.load(ID002RM.path.."/src/blast.png")
ID002RM.img_Bnext = image.load(ID002RM.path.."/src/bnext.png")
ID002RM.img_Bar1 = image.load(ID002RM.path.."/src/barr_1.png")
ID002RM.img_Bar2 = image.load(ID002RM.path.."/src/barr_2.png")

ID002RM.defaultPlayer = {}

--[[ FUNCIONES BASICAS ]]--

function ID002RM.init(id,input) --[[ Aqui se coloca lo que se ejecutar al iniciar la aplicacion (incluyendo la carga de recursos) ]]--
id.iniciandoapp = true
id.porcentage = 0

if input == nil then
	ID002RM.playDefaultFolder(id)
	return
end

ID002RM.play(input)

id.page = 1
id.totalPages =  1
id.scrollbar = scrollbar.new(sdk.x + sdk.w - 8,sdk.y + 31,150,id.page,id.totalPages)
id.iniciandoapp = false
end

function ID002RM.reinit(id,input)
	if input == nil then return end
	ID002RM.play(input)
end

function ID002RM.run(id) --[[ Aqui se coloca el contenido del programa en ejecucion ]]--
local px = sdk.x
local py = sdk.y

ID002RM.img_fondo:blit(px,py)
ID002RM.img_Bar1:blit(px + 173,py + 17);

if puntero.isOver(sdk.x + 2,sdk.y + 2,29,29) then
	puntero.overOn("link")
	if control.press("select") then 
		ID002RM.makePopupAbrir(id) 
	end
end

if puntero.isOver(sdk.x + 39,sdk.y + 2,29,29) then
	puntero.overOn("link")
	if control.press("select") then ID002RM.makePopupListas(id) end
end

if puntero.isOver(sdk.x + 71,sdk.y + 2,29,29) then
	puntero.overOn("link")
	if control.press("select") then ID002RM.makePopupOpciones(id) end
end

if sonido.playing == true then
	ID002RM.img_Blast:blit(px + 111,py + 11)
	ID002RM.img_Bpause:blit(px + 132,py + 11)
	ID002RM.img_Bnext:blit(px + 153,py + 11)
else
	ID002RM.img_Blast:blit(px + 111,py + 11)
	ID002RM.img_Bplay:blit(px + 132,py + 11)
	ID002RM.img_Bnext:blit(px + 153,py + 11)
end

if puntero.isOver(px + 111,py + 11,15,15) then
		puntero.overOn("link")
end

if puntero.isOver(px + 132,py + 11,15,15) then
		puntero.overOn("link")
		if sonido.obj ~= nil then
			if sonido.playing then
				if control.press("select") then
				
					if sonido.porcent == 100 then
						sonido.play()
					else
						sonido.pause()
					end
				end
			else
				puntero.overOn("link")
				if control.press("select") then
					sonido.play()
				end
			end
		else
			
		end
end

if puntero.isOver(px + 153,py + 11,15,15) then
		puntero.overOn("link")
end

if sonido.obj ~= nil and sonido.focus ~= 0 then
	screen.print(px + 173,py + 7,sonido.getPlayName(),0.5,color.new(0,0,0),0x0,"scroll_left",281)
	if sonido.getPlayName() ~= ID002RM.actual then
		ID002RM.efx_1 = 435 - screen.textwidth(sonido.getPlayName(),0.5)
		ID002RM.efx_2 = sdk.x + 168
		ID002RM.actual = sonido.getPlayName()
	end
end

if sonido.obj ~= nil then	
	id.porcentage = sonido.porcent
	local num = (281 / 100 * id.porcentage)
	ID002RM.img_Bar2:blit(px + 173,py + 17,0,0,num,10);
	ID002RM.img_fpoint:blit(px + 173 + num - 5,py + 17)
	
	if puntero.isOver(px + 173,py + 17,281,10) then
		puntero.overOn("link")
		if control.old("select") then
		
			if sonido.playing == false then				
				sonido.play()
			end
			
			local porcent = puntero.x - (px + 173)
			porcent = ((100 / 281) * porcent)
			sound.percent(sonido.obj,porcent)
		end
	end
end

screen.print(px + 20,py + 34,getText("nombre",ID002RM),0.5,color.new(30,30,30),0x0)
screen.print(px + 390,py + 34,getText("tipo",ID002RM),0.5,color.new(30,30,30),0x0)
screen.print(px + 433,py + 34,getText("numero",ID002RM),0.5,color.new(30,30,30),0x0)


local j = 1

for i = id.page,id.page + 7 do 
	
	if sonido.list[i] == nil then break end
	
	local x = px + 20
	local y = py + 49 + ((j - 1) * 15)
		
	if puntero.isOver(x - 5,y,445,14) then
		puntero.overOn("popup_link")
		draw.fillrect(x - 5,y,445,14,color.new(163 + 20,218 + 20,138 + 20,120))
		
		if control.press("select") then
			if sonido.focus ~= i then
				system.printLabel(id.this.path.."/load.png")
			end
			
			sonido.play(i)
			ID002RM.efx_1 = 435 - screen.textwidth(sonido.getPlayName(),0.5)
			ID002RM.efx_2 = sdk.x + 168
			
			system.closeLabel()
		end
	end
	
	if sonido.focus == i then
		ID002RM.img_point:blit(x - 18,y + 1)
	else
		
	end
	
	screen.print(x,y + 2,sonido.list[i].nombre,0.5,color.new(0,0,0),0x0,"scroll_left",355)
	screen.print(x + 400,y + 2,sonido.list[i].extencion,0.5,color.new(0,0,0),0x0,"right")
	screen.print(x + 414,y + 2,i,0.45,color.new(30,30,30),0x0)
	
	j = j + 1
end

if sonido.obj ~= nil then
	if sonido.playing == false or sdk.x ~= 8 then
		local w = screen.textwidth(sonido.getPlayName(),0.5)
		
		if w > 266 then
			screen.print(px + 168,py + 184,sonido.getPlayName(),0.5,color.new(0,0,0),0x0,"scroll_left",266)
		else
			screen.print(px + 168 + 266,py + 184,sonido.getPlayName(),0.5,color.new(0,0,0),0x0,"right",266)
		end
		
		ID002RM.efx_1 = 435 - w
	else
		local w = screen.textwidth(sonido.getPlayName(),0.5)
		
		if w > 266 then
			w = 266
			ID002RM.efx_2 = screen.print(ID002RM.efx_2,py + 184,sonido.getPlayName(),0.5,color.new(0,0,0),0x0,"scroll_left",266)
		else
			ID002RM.efx_1 = screen.print(ID002RM.efx_1,py + 184,sonido.getPlayName(),0.5,color.new(0,0,0),0x0,"scroll_left",w - 2)
		end
	end
end

if sonido.playing == true then
	ID002RM.img_Bpause:blit(px + 443,py + 181)
	if puntero.isOver(px + 443,py + 181,15,15) then
		puntero.overOn("link")
		if control.press("select") then
			if sonido.porcent == 100 then
				sonido.play()
			else
				sonido.pause()
			end
		end
	end
else
	ID002RM.img_Bplay:blit(px + 443,py + 181)
	if puntero.isOver(px + 443,py + 181,15,15) then
		puntero.overOn("link")
		if control.press("select") and sonido.obj ~= nil then
			sonido.play()
		end
	end
end

scrollbar.setVal(id.scrollbar,id.page,id.totalPages)
scrollbar.draw(id.scrollbar)
scrollbar.setLocation(id.scrollbar,sdk.x + sdk.w - 8,sdk.y + 31,150)

if app.kernel_scroll_ == true then
	if controls.press("up") then
		id.page = id.page - 1
		if id.page < 1 then id.page = 1 end
		if id.page > #sonido.list then id.page = #sonido.list end
	end
	
	if controls.press("down") then
		id.page = id.page + 1
		if id.page < 1 then id.page = 1 end
		if id.page > #sonido.list then id.page = #sonido.list end
	end
	
	if controls.press("left") then
		id.page = id.page - 7
		if id.page < 1 then id.page = 1 end
		if id.page > #sonido.list then id.page = #sonido.list end
	end
	
	if controls.press("right") then
		id.page = id.page + 7
		if id.page < 1 then id.page = 1 end
		if id.page > #sonido.list then id.page = #sonido.list end
	end
end

end

function ID002RM.exit(id) --[[ Aqui se coloca lo que se ejecutar al finalizar la aplicacion (se pueden liberar elementos individuales) ]]--
	if sonido.obj ~= nil then
		sonido.obj:stop()
		sonido.obj:free()
		sonido.obj = nil
	end
end

function ID002RM.free() --[[ Aqui se liberan los recursos que fueron requeridos (se eliminan los elementos GLOBALES) ]]--
	sonido.freeAll()
end

-------------------------------------

---[[ FUNCIONES EXTRAS ]]--

function ID002RM.makePopup(id,archivo)
---element[ejem] = { texto = (nombre del elemento) , accion = (accion de la pulsacion) , est = (boleano que avilita/desavilita el elemento) }
eleme = {}
table.insert(eleme,{ texto = "" , accion = "", est = true , accionToClose = true })

popup.setElements(eleme)
popup.activate()
end

function ID002RM.makePopupAbrir(id)
---element[ejem] = { texto = (nombre del elemento) , accion = (accion de la pulsacion) , est = (boleano que avilita/desavilita el elemento) }
eleme = {}
table.insert(eleme,{ texto = "Abrir sonido" , accion = "ID002RM.abirSonido("..id.this.IDI..")", est = true , accionToClose = true })
table.insert(eleme,{ texto = "Abrir lista de reproduccin" , accion = "", est = false , accionToClose = true })
table.insert(eleme,{ texto = "Abrir todos los sonidos de un folder" , accion = "ID002RM.openFolder("..id.this.IDI..")", est = true , accionToClose = true })
table.insert(eleme,{ texto = "Guardar lista" , accion = "", est = false , accionToClose = true })
popup.setElements(eleme)
popup.activate()
end

function ID002RM.makePopupListas(id)
---element[ejem] = { texto = (nombre del elemento) , accion = (accion de la pulsacion) , est = (boleano que avilita/desavilita el elemento) }
eleme = {}
table.insert(eleme,{ texto = "Crear lista de reproduccin" , accion = "", est = false , accionToClose = true })
table.insert(eleme,{ texto = "Aadir sonido a la lista" , accion = "", est = false , accionToClose = true })
table.insert(eleme,{ texto = "Aadir todos los sonidos de un folder" , accion = "ID002RM.addFolder("..id.this.IDI..")", est = true , accionToClose = true })

popup.setElements(eleme)
popup.activate()
end

function ID002RM.makePopupOpciones(id)
---element[ejem] = { texto = (nombre del elemento) , accion = (accion de la pulsacion) , est = (boleano que avilita/desavilita el elemento) }
eleme = {}
table.insert(eleme,{ texto = "Borrar lista de reproduccion" , accion = "", est = false , accionToClose = true })
table.insert(eleme,{ texto = "Borrar pistas de la lista" , accion = "", est = false , accionToClose = true })
table.insert(eleme,{ texto = "Preferencias" , accion = "", est = false , accionToClose = true })

popup.setElements(eleme)
popup.activate()
end

function ID002RM.play(ruta)
	if files.ext(ruta) == "mp3" or files.ext(ruta) == "bgm" or files.ext(ruta) == "wav" or files.ext(ruta) == "at3" then else return end
	if files.exists(ruta) == false then return end
	
	sonido.addList(ruta)
	sonido.play(#sonido.list)
	
	ID002RM.actual = ruta
	ID002RM.efx_1 = 435 - screen.textwidth(sonido.getPlayName(),0.5)
	ID002RM.efx_2 = sdk.x + 168
end

function ID002RM.playDefaultFolder(id)
	local rut
	
	if system.isGO == true then
		rut = "ef0:/MUSIC"
	else
		rut = "ms0:/MUSIC"
	end
	
	ID002RM.playFolder(id,rut,true)
	
end

function ID002RM.openFolder(id)
	local currentDir
	
	if system.isGO == true then
		currentDir = "ef0:/"
	else
		currentDir = "ms0:/"
	end
	
	FILE_SELECTOR_TYPE = "folders"					--- Solo se permiten archivos
	FILE_SELECTOR_INIT_PATH = currentDir			--- Current directory (directorio de inicio)
	FILE_SELECTOR_MULTIPLE_INTERVAL = true			--- Permite seleccionar multibles archivos
	
    local ruta = system.runPortal("ms0:/FISHELL/SRC/PORTAL/FILE_SELECTOR")
	
	if ruta == nil then return end
	
	if id.iniciandoapp ~= true then
		system.printLabel("load")
	end
	
	if type(ruta) == "table" then
		for i = 1,#ruta do
			sonido.reset()
			ID002RM.playFolder(id,ruta[i])
		end
	else
		ID002RM.playFolder(id,ruta,true)
	end
	
	if id.iniciandoapp ~= true then
		system.closeLabel()
	end
end

function ID002RM.abirSonido(id)
	
	local currentDir
	
	if system.isGO == true then
		currentDir = "ef0:/"
	else
		currentDir = "ms0:/"
	end
	
	FILE_SELECTOR_TYPE = "files"					--- Solo se permiten archivos
	FILE_SELECTOR_FILTER = { "mp3" , "bgm" , "wav" , "at3" }	--- Filtro de archivos prx
	FILE_SELECTOR_NAME_FILTER = "Archivos de sonido" 			--- Nombre del filtro
	FILE_SELECTOR_INIT_PATH = currentDir.."MUSIC"		--- Current directory (directorio de inicio)
	FILE_SELECTOR_MULTIPLE_INTERVAL = true			--- Permite seleccionar multibles archivos
	
    local ruta = system.runPortal("ms0:/FISHELL/SRC/PORTAL/FILE_SELECTOR")
	
	if ruta == nil then
		return
	end
	
	if id.iniciandoapp ~= true then system.printLabel("load") end
	
	sonido.reset()
	
	if type(ruta) == "table" then
		for i = 1,#ruta do
			sonido.addList(ruta[i])
		end
	else
		ID002RM.play(ruta)
	end
	
	if id.iniciandoapp ~= true then system.closeLabel() end
end

function ID002RM.addFolder(id)
	local currentDir
	
	if system.isGO == true then
		currentDir = "ef0:/"
	else
		currentDir = "ms0:/"
	end
	
	FILE_SELECTOR_TYPE = "folders"					--- Solo se permiten archivos
	FILE_SELECTOR_INIT_PATH = currentDir			--- Current directory (directorio de inicio)
	FILE_SELECTOR_MULTIPLE_INTERVAL = true			--- Permite seleccionar multibles archivos
	
    local ruta = system.runPortal("ms0:/FISHELL/SRC/PORTAL/FILE_SELECTOR")
	
	if ruta == nil then return end
	
	system.printLabel("load")
	
	if type(ruta) == "table" then
		for i = 1,#ruta do
			ID002RM.playFolder(id,ruta[i])
		end
	else		
		ID002RM.playFolder(id,ruta)
	end
	
	system.closeLabel()
end

function ID002RM.playFolder(id,ruta,reemplazar)

	if files.exists(ruta) == false then
		System.mensaje(getText("Error"),"El directorio no existe")
		return
	end
	
	local isDir = uld.getFile(ruta).directory
	
	if isDir == false then return end
	
	if id.iniciandoapp~= true then system.printLabel("load") end
	
	if reemplazar == true then
		sonido.reset()
	end
	
	local arch = files.listfiles(ruta)
	
	for i = 1,#arch do
		if files.ext(arch[i].name) == "mp3" or files.ext(arch[i].name) == "bgm" or files.ext(arch[i].name) == "wav" or files.ext(arch[i].name) == "at3" then
			sonido.addList(arch[i].name)
		end
	end
	
	id.page = 1
	id.totalPages =  #sonido.list
	id.scrollbar = scrollbar.new(sdk.x + sdk.w - 8,sdk.y + 31,150,id.page,id.totalPages)
	
	if id.iniciandoapp ~= true then system.closeLabel() end
	
	if #sonido.list > 0 and id.iniciandoapp ~= true then
		sonido.play(1)
	end
end