function ID007TA.initPortals(id)
	id.pestana = "portales"
	id.portales = ID007TA.loadPortals(id,1)
	id.scrollbar = scrollbar.new(sdk.x + sdk.w - 10,sdk.y + 35,sdk.h - 40,id.page,id.total_pages)
end

function ID007TA.loadPortals(id,page)
	--local list = system.dofile("ms0:/FISHELL/SRC/FUNCTIONS/portales_panel.lua")
	if page < 1 then page = 1; return end
	if page > math.ceil(table.maxn(list) / 5) then page = math.ceil(table.maxn(list) / 5); return end
	
	local list = {}
	local dirs = files.listdirs("ms0:/FISHELL/PORTAL")
	id.programList = nil
	
	for i = 1 + ((page - 1) * 5),((page - 1) * 5) + 5 do
	
		if dirs[i] == nil then break end
		
		if files.exists(dirs[i].name.."/DATA.ini") then
			table.insert(list,dofile(dirs[i].name.."/DATA.ini"))
			
			list[#list].id = files.nopath(dirs[i].name)
			
			if files.exists(dirs[i].name.."/icon.png") then
				list[#list].img = image.load(dirs[i].name.."/icon.png")
			else
				list[#list].img = image.load(LOG_THEME_PATH.."CUSTOM/icon/functions/unknown.png")
			end
		end
	end
	
	id.page = page
	id.programList = list
	id.total_pages = math.ceil(table.maxn(list) / 6)
end

function ID007TA.drawPortals(id)
	if id.programList == nil then return end
	if app.kernel_scroll_ == true then
		if controls.press("down") then
			ID007TA.loadPortals(id,id.page + 1)
		end
		
		if controls.press("up") then
			ID007TA.loadPortals(id,id.page - 1)
		end
	end
	
	for i = 1,#id.programList do
		local x = sdk.x + 4
		local y = sdk.y + 28 + ((i - 1) * 33)
		
		if puntero.isOver(x - 2,y + 3,436,30) and kernel.isPopup == false then
			puntero.overOn("popup_link")
			ID007TA.img_pstfocusover:blend(x - 2,y + 3)
			if control.press("select") then
				--app.load(id.programList[i].id)
				--assert(loadstring(id.programList[i].obj.chunk))();
				system.runPortal(id.programList[i].id)
			end
			
			if control.press("menu") then
				id.focopopupid = i
				--ID007TA.portalsPopup(id,id.programList[i].obj)
			end
		else
			if kernel.isPopup == true and id.focopopupid == i then
				ID007TA.img_pstfocusover:blend(x - 2,y + 3)
			else
				ID007TA.img_listbar:blit(x - 2,y + 3)
			end
		end
		
		id.programList[i].img:blit(x,y)
		screen.print(x + 40,y + 15,id.programList[i].title,0.6,color.new(20,20,20),color.new(255,255,255,180),"scroll_left",250)
		--screen.print(x + 285,y + 15,"ID: "..id.programList[i].id,0.6,color.new(20,20,20),color.new(255,255,255,180),"scroll_left",80)
	end
	
	scrollbar.setVal(id.scrollbar,id.page,id.total_pages)
	scrollbar.draw(id.scrollbar)
	scrollbar.setLocation(id.scrollbar,sdk.x + sdk.w - 10,sdk.y + 35)
end

function ID007TA.portalsPopup(id,obj)
---element[ejem] = { texto = (nombre del elemento) , accion = (accion de la pulsacion) , est = (boleano que avilita/desavilita el elemento) }
local eleme = {}

table.insert(eleme,{ texto = "Crear Acceso directo" , accion = "", est = false })
table.insert(eleme,{ texto = "Descripcin" , accion = "", est = false })
table.insert(eleme,{ texto = "Desinstalar" , accion = "", est = false })

popup.setElements(eleme)
popup.activate()
end