function ID007TA.initProgramas(id)
	id.pestana = "programas"
	id.tdb = 0
	id.pdb = 0
	if files.exists(LOG_LANG_PATH.."apps_names.txt") then 
		dofile(LOG_LANG_PATH.."apps_names.txt")
	end
	id.programas = ID007TA.loadPrograms(id,1)
	
	id.scrollbar = scrollbar.new(sdk.x + sdk.w - 10,sdk.y + 35,sdk.h - 40,id.page,id.total_pages)
end

function ID007TA.loadPrograms(id,page)
	list = {}
	list = files.listdirs("ms0:/FISHELL/APP")
	
	local lista = {}
	local imagen_ = ""
	
	if page < 1 then page = 1 end
	if page > math.ceil(#list / 5) then page = math.ceil(#list / 5) end
	
	id.programList = nil
	
	for i = 1 + ((page - 1) * 5),((page - 1) * 5) + 5 do
		if list[i] == nil then break end
		local id = files.nopath(list[i].name)
		
		if files.exists(list[i].name.."/app.lua") or files.exists(list[i].name.."/app.lue") then
			if files.exists(list[i].name.."/icon.png") then
				imagen_ = image.load(list[i].name.."/icon.png")
			else
				imagen_ = image.load("ms0:/FISHELL/IMG/SYSTEM/WINDOW/no_icon.png")
			end
			
			local titulo = "(unknown)"
			
			if INSTALL_APP[id] ~= nil then
				titulo = INSTALL_APP[id]
			end
			
			table.insert(lista,{ 
				nombre = titulo ,
				imagen = imagen_ ,
				id = id,
				})
		end
	end
	
	id.page = page
	id.programList = lista
	id.total_pages = math.ceil(#list / 5)
end

function ID007TA.drawPrograms(id)
	if id.programList == nil then return end
	if app.kernel_scroll_ == true then
		if controls.press("down") then
			ID007TA.loadPrograms(id,id.page + 1)
		end
		
		if controls.press("up") then
			ID007TA.loadPrograms(id,id.page - 1)
		end
	end
	
	for i = 1,#id.programList do
		local x = sdk.x + 4
		local y = sdk.y + 28 + ((i - 1) * 33)
		
		if puntero.isOver(x - 2,y + 3,436,30) and kernel.isPopup == false then
			puntero.overOn("popup_link")
			ID007TA.img_pstfocusover:blend(x - 2,y + 3)
			if control.press("select") then
				app.load(id.programList[i].id)
			end
			if control.press("menu") then
				id.focopopupid = i
				ID007TA.ProgramsPopup(id,id.programList[i])
			end
		else
			if kernel.isPopup == true and id.focopopupid == i then
				ID007TA.img_pstfocusover:blend(x - 2,y + 3)
			else
				ID007TA.img_listbar:blit(x - 2,y + 3)
			end
		end
		
		id.programList[i].imagen:blit(x,y)
		screen.print(x + 40,y + 15,id.programList[i].nombre,0.6,color.new(20,20,20),color.new(255,255,255,180),"scroll_left",250)
		screen.print(x + 285,y + 15,"ID: "..id.programList[i].id,0.6,color.new(20,20,20),color.new(255,255,255,180),"scroll_left",80)
	end
	
	scrollbar.setVal(id.scrollbar,id.page,id.total_pages)
	scrollbar.draw(id.scrollbar)
	scrollbar.setLocation(id.scrollbar,sdk.x + sdk.w - 10,sdk.y + 35)
--[[	
	draw.fillrect(sdk.x + 443, sdk.y + 31,15,163,color.new(200,200,200))
	
	if id.total_pages ~= 0 then 
	local tdb = 161 / id.total_pages
	local pdb = (id.page - 1) * tdb
	
	if tdb > id.tdb then id.tdb = id.tdb + 2 end
	if tdb < id.tdb then id.tdb = id.tdb - 2 end
	
	if pdb > id.pdb then id.pdb = id.pdb + 2 end
	if pdb < id.pdb then id.pdb = id.pdb - 2 end
	
	draw.fillrect(sdk.x + 445,sdk.y + 33 + id.pdb,11,id.tdb,color.new(120,120,120))
	
	end
]]--
end

function ID007TA.ProgramsPopup(id,obj)
---element[ejem] = { texto = (nombre del elemento) , accion = (accion de la pulsacion) , est = (boleano que avilita/desavilita el elemento) }
local eleme = {}
local chunk_mkaccsdir = "descktop.makeAccsDir(\""..obj.nombre.."\",\"install/icon.png\",\"APP\",\""..obj.id.."\")"

table.insert(eleme,{ texto = "Abrir Ubicación" , accion = "launch.custom(\"ms0:/FISHELL/APP/"..obj.id.."\")" , est = true , accionToClose = true })
table.insert(eleme,{ texto = "Crear Acceso directo" , accion = chunk_mkaccsdir, est = true , accionToClose = true})
table.insert(eleme,{ texto = "Desinstalar" , accion = "", est = false })
table.insert(eleme,{ texto = "Descripción" , accion = "", est = false })

popup.setElements(eleme)
popup.activate()
end