----------------------------------------------------------
----- MODULO ADMINISTRADOR DE CUENTAS "ACOUNT ADMIN" -----
----------------------------------------------------------
-- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com

acount = {}
acount.cuentas = {}
acount.ekey = 11

function acount.create(name,pass_)
	
	if name == nil then return 1 end
	if acount.isExist(name) then return 2 end
	
	local isLock_ = true
	
	if pass_ == nil or pass_ == "" then 
		pass_ = "null"
		isLock_ = false
	end
	
	table.insert(acount.cuentas,{ name = name, isLock = isLock_, pass = pass_, date = os.time() })
	
	return acount.saveAll()
end

function acount.saveAll()
	if #acount.cuentas == 0 then return false end
	
	local result = {}
	
	--- Concatenando cuentas ---
	for i = 1,#acount.cuentas do
		local res = acount.cuentas[i].name..":#:"..tostring(acount.cuentas[i].isLock)..":#:"..acount.cuentas[i].pass..":#:"..acount.cuentas[i].date..":#:"
		table.insert(result,res)
	end
	
	--- Encriptando cuentas ---
	for i = 1,#result do
		result[i] = uld.code.new(result[i],acount.ekey)
	end
	
	--- Guardando cuentas ---	
	uld.writeFile("ms0:/FISHELL/USR/RDC.RDC",string.format(table.concat(result,"\n")),"w+")
	acount.loadrdc()
	return true
end

function acount.isExist(name)
	acount.loadrdc()
	local result = false
	
	for i = 1,#acount.cuentas do
		if acount.cuentas[i].name == name then
			result = true
		end
	end
	
	return result
end

function acount.getAcounTable(name)
	local result = nil
	
	for i = 1,#acount.cuentas do
		if acount.cuentas[i].name == name then
			result = acount.cuentas[i]
		end
	end
	
	return result
end

function acount.loadrdc()
	acount.cuentas = nil
	acount.cuentas = {}
	
	if files.exists("ms0:/FISHELL/USR/RDC.RDC") == false then
		uld.writeFile("ms0:/FISHELL/USR/RDC.rdc","","w+")
		return
	end
	
	local lineas_codigo = uld.filesRead("ms0:/FISHELL/USR/RDC.RDC")
	local result = {}
	
	for i = 1,#lineas_codigo do
		local line = uld.code.reverse(lineas_codigo[i],acount.ekey)
		local tab = string.explode(line,":#:")		
		table.insert(result,{ name = tab[1] , isLock = tab[2] , pass = tab[3] , date = tab[4] })
	end
	
	acount.cuentas = result
end

acount.loadrdc()