--- Modulo CFGwriter ---
--- Requiere librerias ULD de fishell 
--- Modifica valores de scripts lua
--- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com


CFGW = {} 

function CFGW.write(doc,seccion,valor)
	if seccion == nil then return end
	
	if files.exists(doc) == false then 
		uld.writeFile(doc,"","w+")
	end
	
	local isChange = false
	
	local lineas = uld.filesRead(doc)
	
	for i = 1,#lineas do
		if string.sub(lineas[i],1) == "\r" then
			lineas[i] = string.sub(lineas[i],2,#lineas[i])
			--system.mensaje("Encontrado 1","","")
		end
		if string.sub(lineas[i],#lineas[i]) == "\r" then
			lineas[i] = string.sub(lineas[i],1,#lineas[i] - 1)
			--system.mensaje("Encontrado 2","","")
		end
	end
	
	for i = 1,#lineas do
		local sec1 = string.gettok(lineas[i]," = ",1)
		--local sec2 = string.gettok(lineas[i]," = ",2)
		
		if sec1 == seccion then
			if valor == nil then
				lineas[i] = sec1..tostring(" = nil")
			else
				lineas[i] = sec1.." = "..tostring(valor)
			end
			
			isChange = true 
			break
		end
	end
	
	if isChange == false then
		if valor == nil then
			table.insert(lineas,seccion.." = "..tostring("nil"))
		else
			table.insert(lineas,seccion.." = "..tostring(valor))
		end
		
	end
	 
	uld.writeFile(doc,table.concat(lineas,"\r\n"),"w+")
	
	return true
end

function CFGW.update(input,output)
	
	if files.exists(input) == false then return end
	
	local inLines = uld.filesRead(input)
	local outLines = uld.filesRead(output)
	
	for i = 1,#inLines do
		if string.numtok(inLines[i]," = ") < 2 then return end
		
		local comIn = string.gettok(inLines[i]," = ",1)
		local valIn = string.gettok(inLines[i]," = ",2)
		
		local comOut
		if outLines[i] == nil then
			comOut = nil
		else
			comOut = string.gettok(outLines[i]," = ",1)
		end
		
		if comIn ~= comOut then
			CFGW.write(output,comIn,valIn)
		end
	end
end