--- Modulo install_lib.lua
--- Documentacion para actualizacion e instalacion de cuentas fishell
--- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com

ilib = {}
 
function ilib.reinstallSystem(date,user,lang)  --- Reinstala el sistema basandose en sus argumentos
	system.printLabel("03","Configurando")
	local texInstall = ""
	 
	texInstall = "INSTALL_FECHA = \""..date.."\"\r\n"
	texInstall = texInstall.."INSTALL_NICK = \""..user.."\"\r\n"
	texInstall = texInstall.."INSTALL_LENGUAGE = \""..lang.."\"\r\n"
	texInstall = texInstall.."INSTALL_SYSTEM = "..system.revicion.."\r\n"
	texInstall = texInstall.."INSTALL_SYSTEM_SUB_VER = "..system.sub_version.."\r\n"
	
	uld.writeFile("ms0:/FISHELL/INSTALL/install.ini",texInstall,"w+")
	
	files.copy("ms0:/FISHELL/SRC/INSTALL/INSTALL/install_apps.ini","ms0:/FISHELL/INSTALL/install_apps.ini",true)
	system.closeLabel()
end

function ilib.installUser(nombre,grupo,pass,avatar)
	system.dofile("ms0:/FISHELL/SRC/FUNCTIONS/regusr.lua")
	ilib.initInstallUser(nombre,grupo,pass,avatar)
end

function ilib.updateUser(user)	

	if system.userExist(user) == false then return end
	
	if CFGW == nil then system.dofile("ms0:/FISHELL/SRC/DOC/cfgw.lua") end
		
	local inLines = uld.filesRead("ms0:/FISHELL/SRC/INSTALL/USER/CUSTOM/CFG.ini")
	local outLines = uld.filesRead("ms0:/FISHELL/USR/"..user.."/CUSTOM/CFG.ini")
	
	CFGW.update("ms0:/FISHELL/SRC/INSTALL/USER/CUSTOM/CFG.ini","ms0:/FISHELL/USR/"..user.."/CUSTOM/CFG.ini")
	CFGW.update("ms0:/FISHELL/SRC/INSTALL/USER/CUSTOM/EXEC.ini","ms0:/FISHELL/USR/"..user.."/CUSTOM/EXEC.ini")
	
	CFGW.write("ms0:/FISHELL/USR/"..user.."/data.ini","USR_SISTEMAID",system.rev) 				-- Actualizando revicion del sistema
	CFGW.write("ms0:/FISHELL/USR/"..user.."/data.ini","USR_SISTEMASUBID",system.sub_version) 	-- Actualizando revicion del sistema
	
	CFGW.write("ms0:/FISHELL/INSTALL/install.ini","INSTALL_SYSTEM",system.rev)
	CFGW.write("ms0:/FISHELL/INSTALL/install.ini","INSTALL_SYSTEM_SUB_VER",system.sub_version)
	
	if files.exists("ms0:/FISHELL/RDS/exception_report.txt") then files.remove("ms0:/FISHELL/RDS/exception_report.txt",true,true) end  --- Eliminando reportes antiguos
	
	files.copy("ms0:/FISHELL/SRC/INSTALL/INSTALL/install_apps.ini","ms0:/FISHELL/INSTALL/install_apps.ini",true,true)

end