--- Documentacion para el uso de etiquetas de pantalla
-- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com

label = {}
label.lb = nil
label.isOpen = false

function label.print(id,texto)
	local id = tostring(id)
	
	label.trans = 0
	label.screen = screen.toimage()

	if files.exists(id) == true then
		label.lb = image.load(id)
	else
		label.lb = image.load("ms0:/FISHELL/IMG/SYSTEM/LABEL/"..id..".png")
	end

	if kernel ~= nil and PORTAL_MODE ~= true then 
		kernel.postImage(label.screen) --- esta linea corrige errores visuales con este tipo de eventos
	end 

	label.texto = texto

	for i = 0,255,14 do
		label.screen:blend(0,0,255)
		label.lb:blend(0,0,i)
		screen.print()
		uld.printCenter(179,130,label.texto,0.7,color.new(0,0,0,i),0x0,146)
		screen.flip()
	end

	label.isOpen = true
end

function label.close()
	if label.lb == nil then return end
	
	for i = 255,-14,-14 do
		label.screen:blend(0,0,255)
		label.lb:blend(0,0,i)
		uld.printCenter(179,130,label.texto,0.7,color.new(0,0,0,i),0x0,146)
		screen.flip()
	end

	label.screen:blend(0,0,255)
	screen.flip()

	if label.lb == nil then else label.lb:free() end 
	if label.screen == nil then else label.screen:free() end 

	label.lb = nil
	label.screen = nil
	label.isOpen = false
	collectgarbage("collect")
end