---------------------------------------------------
------------ Script kernel de FISHELL -------------
---------------------------------------------------

-- Script que contiene el bucle infinito del sistema
-- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com

kernel = {} --- Tabla con las variables a nivel nucleo
kernel.isPopup = false
kernel.isOption = false
kernel.overBackground = nil

kernel.backgroundOverDrawTrans = 0
kernel.overbtrans = 255

kernel.portapapeles = ""  -- Portapapeles del sistema

kernel.wlanStatus = wlan.status()

function kernel.postImage(imagen) 	
	if AFS ~= nil and AFS.ENABLED == true then
		kernel.imgloadFS = uld.copyImage(imagen)
		return
	end
	
	kernel.imgload = uld.copyImage(imagen)
end

ef01 = image.create(480,272,color.new(0,0,0)) -- Imagen que proporciena el efecto de entrada al shell
ef01T = 255

--- Cargando configuraciones ---
	if cfg.auto_collectgarbage == true then
		if cfg.auto_collectgarbage_sec == nil then
			cfg.auto_collectgarbage_sec = 10
		end
		
		ACG_TEMP =  timer.new()
		ACG_TEMP:start()
	end
--------------------------------

while true do -- BUCLE INFINITO (Nucleo)

control.runDrive() --- Drive del los controles
sonido.runDrive() --- Drive de las pistas de audio

if cfg.color_backgrounds ~= nil then
	image.fxtint(0,0,IMG_FONDO,color.new(cfg.color_backgrounds.R,cfg.color_backgrounds.G,cfg.color_backgrounds.B))
else
	IMG_FONDO:blend(0,0,255)
end

if kernel.overBackground ~= nil then

	if cfg.color_backgrounds ~= nil then
		image.fxtint(0,0,kernel.overBackground,color.new(cfg.color_backgrounds.R,cfg.color_backgrounds.G,cfg.color_backgrounds.B,kernel.overbtrans))
	else
		kernel.overBackground:blend(0,0,kernel.overbtrans)
	end
    
    if kernel.overbtrans <= 0 then
        kernel.overbtrans = 255
        kernel.overBackground:free()
        kernel.overBackground = nil
        collectgarbage("collect")
    end
    kernel.overbtrans = kernel.overbtrans - 9
end


if cfg.wave == true then 
	fsl.wave.draw(wave,descktop.trans_accs,cfg.color_wave) --- Pintando la onda en el fondo		Modulo: fsl_wave.lua
end

descktop.draw()  --- Dibujando accesos directos y escritorio 		Modulo: descktop.lua
semaforo.draw()  --- Dibujando el "semaforo" de fishell      		Modulo: semaforo.lua

if fishbar.apps_focus == 0 then 
	--- En caso de que no este enfocada ninguna ventana
else
    if descktop.focoin == "escritorio" then 
		app.drawWindow(fishbar.apps[fishbar.apps_focus],-9) --- Desenfocando ventana
    else
		app.drawWindow(fishbar.apps[fishbar.apps_focus],9) --- Enfocando ventana
    end
end

if control.old("scroll",true) and descktop.focoin == "window" and fishbar.apps_focus ~= 0 then --- Controlador del SCROLL_KERNEL al presionar el boton de scroll
    if kernel.isPopup == false and kernel.isOption == false then
        app.kernel_scroll_ = true
        puntero.overOn("scroll")
        control.lock(4673)
		
		if controls.press("l") then
			fishbar.apps_focus = fishbar.apps_focus - 1
			app.trans_blackscreenB = 0
			app.hiperEnfocar()
		end
		
		if controls.press("r") then
			fishbar.apps_focus = fishbar.apps_focus + 1
			app.trans_blackscreenB = 0
			app.hiperEnfocar()
		end
		
		if fishbar.apps_focus > #fishbar.apps then fishbar.apps_focus = 1 end
		if fishbar.apps_focus < 1 then fishbar.apps_focus = #fishbar.apps end
		
    else
        control.unlock(4673)
        app.kernel_scroll_ = false
    end
else
        control.unlock(4673)
        app.kernel_scroll_ = false
end 

fishbar.draw() --- dibujando la fishbar 												    Modulo: fishbar.lua

if kernel.isPopup == true then popup.draw() end  --- Dibujando el menu popup  			    Modulo: popup.lua
if kernel.isOption == true then optionpanel.draw() end -- Dibujando la ventana de opcion 	Modulo: option_panel.lua

if kernel.backgroundOverDrawTrans > 0 then
	IMG_FONDO:blend(0,0,kernel.backgroundOverDrawTrans)
	descktop.drawAccs(kernel.backgroundOverDrawTrans - 65)
end

puntero.draw() --- dibuja el puntero en su posicion											Modulo: mouse.lua

if ef01T ~= nil and ef01T > 0 then
    ef01:blend(0,0,ef01T); ef01T = ef01T - 10; 
    if ef01T <= 0 then ef01T = nil; ef01:free()  end 
end

if kernel.imgload == nil then 
    if cfg.waitrefresh == true then screen.waitvblank() end
    screen.flip()
else
    kernel.imgload:blend(0,0,255)
    screen.waitvblank()
    screen.flip()
    kernel.imgload:free()
    kernel.imgload = nil
    collectgarbage("collect")
end

--- Funciones paralelas del tipo kernel ---

if cfg.auto_collectgarbage == true then
	if ACG_TEMP:time() >= (cfg.auto_collectgarbage_sec * 1000) then
		ACG_TEMP:reset()
		collectgarbage()
	end
end

---------------------------------------------------

if control.press("home") then 
	home.run() --- Activa el menu home de fishell 									Modulo: home.lua
end

if controls.press("start") then 
--[[
objeto = dofile("ms0:/prueva.lua")
system.mensaje("antes","",objeto.x)
objeto.x = 10
system.mensaje("despues","",objeto.x)
--
	if controls.cross() then
		launch.lhms("adhoc_catcher.lua","","ms0:/FISHELL/LHM/EBOOT_B.PBP")
		return
	end
	
	launch.lhms("adhoc_sender.lua","","ms0:/FISHELL/LHM/EBOOT_B.PBP")
]]--
end

if sdk ~= nil and app.window_rage == true and descktop.focoin == "window" then
    if control.old("select") then --- Arrastrado de ventanas
        if puntero.x > app.window_rage_X then
            sdk.x = sdk.x - (app.window_rage_X - puntero.x)
            app.window_rage_X = puntero.x
            if sdk.x > semaforo.w + 10 then sdk.x = semaforo.w + 15 end
            sdk.objx = sdk.x
        end
    
        if puntero.x < app.window_rage_X then
            sdk.x = sdk.x + (puntero.x - app.window_rage_X)
            app.window_rage_X = puntero.x
            if sdk.x < -78 then sdk.x = -78 end
            sdk.objx = sdk.x
        end
    end
    
    if control.relase("select") then
        app.window_rage = false
        if app.window_rage_first == puntero.x then
            sdk.objx = 8
        end
    end
end

if controls.hold() == true then standby.init() end -- Inicia el modo bloqueo de los controles

power.tick(power.tick_all) -- evita que la psp apage la pantalla y se suspenda
end
