--- Face de instalacion del sistema ---
--- Autor@: zerozelta

system.loadLanguage(os.language())
INSTALL_LNG = system.selectLanguage()

--- Cargando SPLASH del sistema
uld.splash("ms0:/FISHELL/IMG/SPLASH/zerozelta.png",100)		--- Splash zerozelta
os.luadevsplash()											--- Splash luaDEV
-------------------------------------

system.loadLanguage(INSTALL_LNG) --- Cargando idioma seleccionado
controls.homepopup(1)

--- Iniciando la instalacion ---

install = {}
install.img_instalando = image.load("ms0:/FISHELL/IMG/INSTALL/installing.png")

for i = 0,255,10 do
	install.img_instalando:blend(0,0,i)
	screen.flip()
end

controls.homepopup(0)

--------------------------------------------------------------------------------------
-------------- Limpiesa de archivos --------------------------------------------------
--------------------------------------------------------------------------------------

uld.writeFile("ms0:/FISHELL/USR/RDC.rdc","","w+")  --- Limpiando registro

local users_garbage = files.listdirs("ms0:/FISHELL/USR")

for i = 1,#users_garbage do
	files.remove(users_garbage[i].name,true)
end

if files.exists("ms0:/FISHELL/RDS/LOG/loged.isf") then files.remove("ms0:/FISHELL/RDS/LOG/loged.isf") end
if files.exists("ms0:/FISHELL/RDS/inicial.ice") then files.remove("ms0:/FISHELL/RDS/inicial.ice") end

--------- Cargando Modulos Necesarios -------------
---------------------------------------------------

system.dofile("ms0:/FISHELL/SRC/DOC/osk.lua") 			--- Documentacion para el osk modificado
system.dofile("ms0:/FISHELL/SRC/DOC/install_lib.lua")	--- Documentacion para instalaciones

INSTALL_FECHA = os.time()
INSTALL_NICK = os.nick()

ilib.reinstallSystem(INSTALL_FECHA,INSTALL_NICK,INSTALL_LNG) -- Configurando sistema con sus argumentos

files.copy("ms0:/FISHELL/SRC/INSTALL/GLOBAL","ms0:/FISHELL/CFG",true) -- Copiando todas las CONFIGURACIONES GLOBALES

function getUser()
	INSTALL_USUARIO = osk.getText("Escribe el nombre de la primer cuenta que fishell va a crear","nombre",50)
	return INSTALL_USUARIO 
end

---------------------- Instalando Cuenta de usuario --------------------------------------

ilib.installUser(getUser(),"ADMIN",nil,"ms0:/FISHELL/IMG/INSTALL/admin_avatar.png") -- Instala nuevo usuario en el sistema

install_usr = "INSTALL_USUARIO = \""..INSTALL_USUARIO.."\""
uld.writeFile("ms0:/FISHELL/INSTALL/install_usr.ini",install_usr,"w+")

------------------------------------------------------------------------------------------

system.printLabel("03","write autoboot")

	include("autoboot") 	--- incluimos el modulo autoboot
	autoboot.writeVSH()		--- escribimos en el vsh.txt
	autoboot.active()		--- activando modulo
	
system.closeLabel()

system.mensaje(getText("instalacion finalizada"),"correcto",getText("sistema instalado"))
system.efectDifuse()

dofile("script.lua")