-- Menu Recovery del sistema FISHELL --
-- zerozelta | zerozelta@hotmail.com --
screen.print(5,5,"loading",0.5,color.new(255,0,0),0x0)
screen.flip()
screen.waitvblankstart(40)

focopos = 1
mensaje = ""

---_Cargando libreria ULD_---
dofile("uld_lib/ULD.lua")

---_Cargando modulo SYSTEM_---
if files.exists("ms0:/FISHELL/SRC/DOC/system.lue") then
	dofile("ms0:/FISHELL/SRC/DOC/system.lue")
else
	dofile("ms0:/FISHELL/SRC/DOC/system.lua")
end

system.dofile("ms0:/FISHELL/SRC/DOC/autoboot.lua")

if files.exists("ms0:/FISHELL/INSTALL/install.ini") then -- Comprovando que este instalado el fishell
	dofile("ms0:/FISHELL/INSTALL/install.ini")
else
	return
end

if INSTALL_LENGUAGE == nil then
	INSTALL_LENGUAGE = "unknown"
end

if files.exists("ms0:/FISHELL/LANG/"..INSTALL_LENGUAGE.."/recovery.lua") == false then
	INSTALL_LENGUAGE = "unknown"
end

LANG_PATH = "ms0:/FISHELL/LANG/"..INSTALL_LENGUAGE.."/"

dofile(LANG_PATH.."recovery.lua")

opciones = {}
opciones[1] = { name = lng["activar drive usb"] , chunk = "usb.on()" }
opciones[2] = { name = lng["instalar autobootprx"] , chunk = "autoboot.dropVSH(); autoboot.writeVSH();  autoboot.active()" }
opciones[3] = { name = lng["desinstalar autobootprx"] , chunk = "autoboot.dropVSH(); autoboot.desactive()" }
opciones[4] = { name = lng["desinstalar fishell"] , chunk = "uld.dofile('ms0:/PSP/GAME/FISHELL/recovery/uninstall.lua')" }
opciones[5] = { name = lng["reestablecer sistema"] , chunk = "reestablecer_todo()" }
opciones[6] = { name = lng["salir del menu recovery"] , chunk = "os.exit()" }


function lecuraControles()
	controls.read()
	if controls.press("circle") then os.runeboot(files.cdir().."/EBOOT.PBP") end
	if controls.press("down") then focopos = focopos + 1 end
	if controls.press("up") then focopos = focopos - 1 end
	if focopos > #opciones then focopos = 1 end
	if focopos < 1 then focopos = #opciones end
	
	if controls.press("cross") then 
		---assert(loadstring(opciones[focopos].chunk))();
		actionchunk(opciones[focopos].chunk)
	end
end

function actionchunk(chunk)
screen.print(5,260,"loading...",0.5,color.new(255,255,255),0x0)
screen.flip()
screen.waitvblankstart(40)
assert(loadstring(chunk))();
screen.print(5,260,"Complete!!",0.5,color.new(255,255,255),0x0)
screen.flip()
screen.waitvblankstart(40)
end

function reestablecer_todo()
	system.dofile("ms0:/FISHELL/SRC/FUNCTIONS/reestablecer_sistema.lua")
end

while true do
screen.print(5,5,lng["menu recovery"],0.6,color.new(255,255,255),0x0)
for i = 1,#opciones do
	if focopos == i then
		screen.print(5,20 + ((i - 1) * 10),opciones[i].name,0.5,color.new(255,0,0),0x0)
	else
		screen.print(5,20 + ((i - 1) * 10),opciones[i].name,0.5,color.new(255,255,255),0x0)
	end
end
screen.flip()
lecuraControles()
end